/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Extensions for Dojo
*
* (C) Copyright IBM Corp. 2011.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("dojoe.table._ConfigureColumnsDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Form");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.LayoutContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit._Container");

dojo.require("dojoe.table._TableOptions");

// NLS
dojo.requireLocalization("dojoe.table", "Table");
// define the widget class
dojo.declare ("dojoe.table._ConfigureColumnsDialog", [ dijit._Widget, dijit._Templated ],{
		widgetsInTemplate: true,
		// Path to the template
		templateString : dojo.cache("dojoe.table","templates/ConfigureColumnsDialog.html"),		
		optionsWidget_: null,
		constructor: function() {
			this.resources_ = dojo.i18n.getLocalization("dojoe.table", "Table", this.lang);
		},		
		postCreate: function() { 
			this.inherited ("postCreate", arguments);
			this.optionsWidget_=new dojoe.table._TableOptions({
				grid: this.grid
			}, dojo.byId(this.id + "columnsVisibleDivContainer"));
			this.optionsWidget_.startup();		
		},		
		onSelectAll: function(){		
			this.optionsWidget_.onSelectAll();
		},		
		onDeselectAll: function(){		
			this.optionsWidget_.onDeselectAll();
		},		
		onOK: function () {
			this.optionsWidget_.onSave();
			this.hide();
		},		
		onCancel: function () {
			this.hide();
		},		
		show: function () {
			this.dialog.show();
			dijit.byId (this.id + "tabs").resize();
		},		
		hide: function () {
			this.dialog.hide();
			setTimeout (dojo.hitch (this, this.kill), 100);
		},		
		kill: function () {
			var id = this.id;
			this.destroyRecursive();
			dijit.registry.remove (id);
		},		
		getTableOptions: function () {
			return this.optionsWidget_;
		},
		destroy: function () {
			//memory leak issue: custom destroy method to take care of removing all widgets					
			try{
				delete this.resources_;
				//this is for destroying child templated widgets 
				//this should happen by itself but need to figure out why dijit._Templated is not taking care of it...
				var widgets = dijit.findWidgets(this.domNode);
				dojo.forEach(widgets, function(w) {
					if(w){
						if(w.destroyRecursive){
							w.destroyRecursive();
						} else if(w.destroy){
							w.destroy();
						}
					}
				});
				// this is for widgets added as child to this widget and their children..
				//not present in template
				var widgetArr = this.getChildren();
				dojo.forEach(widgetArr, function (child) {
					if(child){
						if(child.destroyRecursive){
							child.destroyRecursive();
						} else if(child.destroy){
							child.destroy();
						}
					}
				});
				this.inherited(arguments);
			}catch(ex){
				console.warn("Widget destroy failed: "+this.id+", ex="+ex.name+":"+ex.message);
			}
		}
	}
);