
dojo.provide("ibm.tivoli.tip.charts.dojo.WidgetController");

dojo.require ("ibm.tivoli.tip.charts.dijit.DojoChartBuilder");
dojo.require ("ibm.tivoli.tip.charts.dijit.TableBuilder");

dojo.declare("ibm.tivoli.tip.charts.dojo.WidgetController", null,{

	global: null,
	namespace: null,
	iscNamespace: null,
	widgetDef: null,
	widgetParams: null,
	builder: null,
	widgetDomNode: null,
	widgetSize: null,
	_isChart: null,
	
	constructor: function (params) {
		console.log("enter WidgetController.constructor");
		this.widgetDef = null;
		this.widgetParams = null;
		this.global = null;
		this.namespace = null;
		this.iscNamespace = null;
		this.builder = null;
		this.widgetDomNode = null;
		this.widgetSize = null;
		this._isChart = true;
	    dojo.mixin( this, params );	
		console.log("exit WidgetController.constructor");
	},
	
	_buildWidgetParams: function(){
		console.log("enter WidgetController._buildWidgetParams");
		var isResizeLate = false;
		if(!this.widgetSize){
			this.widgetSize = {w:400,h:400};
			isResizeLate = true;
		}
		this.widgetParams = {
			global: this.global,
			_widgetSize: this.widgetSize,
			isResizeLate: isResizeLate,
			providerID: this.widgetDef.provider.id,
			datasourceID: this.widgetDef.datasource.id,
			chartID: this.widgetDef.meta.id,		
			tableID: this.widgetDef.meta.id,
			widgetDefinition: this.widgetDef
		};		
		console.log("exit WidgetController._buildWidgetParams");
	},

	buildWidget: function () {
		console.log("enter WidgetController.buildWidget");
		this.busyPane = new ibm.tivoli.tip.dijit.BusyPane({id: this.global.namespaceID('busy_pane')}, dojo.byId(this.namespace+"busy_pane"));
		this.busyPane.show(true);
		this._buildWidgetParams();
		this.widgetDomNode = dojo.byId(this.namespace+"widgetDiv");
		if ((this.widgetDef.charts) && (this.widgetDef.charts[0].type == "Table") || ((this.widgetDef.tables) && (this.widgetDef.tables.length > 0))) {
			this._isChart = false;			
			this._buildTable();
		} else {
			this._isChart = true;
			this._buildChart();
		}
		this.global.builder = this.builder;
		console.log("exit WidgetController.buildWidget");
	},
	
	resizeWidget: function(size){
		console.log("enter WidgetController.resizeWidget");		
		if(!(size && size.w && size.h)){			
			var portletSize = iscPortlet.getPortletSize(this.iscNamespace);			
			size = { w: portletSize.available.w-10, h: portletSize.available.h-5 };
		}				
		if(!this.widgetSize||(this.widgetSize.w!=size.w || this.widgetSize.h!=size.h)){			
			this.widgetSize = size;				
			if(this.builder.isChartBuilt == true){				
				this.builder.resize(dojo.clone(this.widgetSize));	
			}else{		
				this.builder.setWidgetSize(dojo.clone(this.widgetSize));				
			}					
		}
		console.log("exit WidgetController.resizeWidget");
	},

	_buildChart: function () {	
		console.log("enter WidgetController._buildChart");
		this.builder = new ibm.tivoli.tip.charts.dijit.DojoChartBuilder(this.widgetParams,this.widgetDomNode); 
		this.builder.startup();		
		this.chartBuildSub = dojo.subscribe ("ChartBuilder.chartBuilt" + this.builder.id, dojo.hitch(this,function(){			
			this.busyPane.hide();			
		})); 
		console.log("exit WidgetController._buildChart");
	},
	
	_buildTable: function () {	
		console.log("enter WidgetController._buildTable");
		this.widgetParams.div = this.widgetDomNode;		
		this.builder = new ibm.tivoli.tip.charts.dijit.TableBuilder(this.widgetParams);			
		this.builder.startup();			
		console.log("exit WidgetController._buildTable");
	},
	
	cleanup: function(){
		this.builder.destroyRecursive();
		this.busyPane.destroyRecursive();
		dojo.unsubscribe(this.chartBuildSub);
	}
});
