/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.SearchDialog");

dojo.require("dijit.dijit");
dojo.require("dijit.Dialog");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("dojox.data.dom");
dojo.require("ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");

ibm.tivoli.tip.navwidget.topology.dijit.SearchDialog._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.topology.dijit.SearchDialog");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.SearchDialog",
		[dijit.Dialog, ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView],
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		//***************************
		// "Public"
		//***************************	
		// isCenterInViewEnabled: [public] Boolean
		//		Coming soon
		isCenterInViewEnabled: true,
		
		// isClearSearchEnabled: [public] Boolean
		//		Coming soon
		isClearSearchEnabled: true,
		
		// isCloseSearchEnabled: [public] Boolean
		//		Coming soon
		isCloseSearchEnabled: true,
		
		// hideOnCenterOrHighlight: [public] Boolean
		//		Coming soon
		hideOnCenterOrHighlight: true,
		
		//_dataChangedWhileHidden: [private] Boolean
		//		Coming soon
		_dataChangedWhileHidden: false,
		
		//_isClosed: [private] Boolean
		//		Coming soon
		_isClosed: true,

		//*************************** 
		// "Private"
		//***************************	
	
		// _trace: [private] ibm.tivoli.navmodel.Trace
		//		Utility for trace and logging
	    _trace: ibm.tivoli.tip.navwidget.topology.dijit.SearchDialog._trace,
	    
	    // _itemsTableView: [private]
	    //		Coming soon
	    _itemsTableView: null,

	    // _centerInViewButton: [private]
	    //		Coming soon
	    _centerInViewButton: null,
	    
	    // _highlightButton: [private]
	    //		Coming soon
	    _highlightButton: null,
	    
	    // _centerInViewButton: [private]
	    //		Coming soon
	    _clearSearchButton: null,
	    
	    // _closeSearchButton: [private]
	    //		Coming soon
	    _closeSearchButton: null,
	    
		constructor: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			//set title
			this.title =  this.commonResources.SEARCH_TEXT;
			
	        //We don't have a widget def specific to this view, so let's signal to 
	        //super class not to try and load any widget defs on our behalf
			this._usesWidgetDefinition = false;
		},
		
        
		postCreate: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Call superclass
			this.inherited(arguments);
		},

		startup: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			this._itemsTableView.startup();
			this.show();
			
			this.inherited(arguments);	
		},
		
		show: function() {
			//Call superclass
			this.inherited(arguments);
			
			//Refresh the table if data had changed while we were hidden
			if (this._dataChangedWhileHidden && this._itemsTableView) {
				this._itemsTableView.refresh();
			}
			
			this._isClosed = false;
			this._dataChangedWhileHidden = false;
			
			/*
			 * 254135
			 * The code below is a temporary workaround to
			 * ensure that the focus is not returned to the <object> node that contains the
			 * Flash plugin for the canvas (as that cannot be done with javascript).  Instead
			 * return the focus to the DIV container for the canvas.
			 */
	        if (this._savedFocus.node.id && this._savedFocus.node.id.indexOf("SWFObject") > 0) {
	        	this._savedFocus.node = this.managingPluggableView._canvas.domNode;
	        }
		},
		
		hide: function() {
			//Remember we're closed
			this._isClosed = true;
			
			//Call super class
			this.inherited(arguments);
		},
	
		destroy: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

            this.inherited(arguments);
		},		
		
		_setDatasetCleanUpAfterLastDataset: function() {
			//Call super
			this.inherited(arguments);
			
			//Forget about any data changes in previous dataset
			this._dataChangedWhileHidden = false;
		},
		
		_setDatasetCreatePluggableViews: function() {
			//See if we've been called before
			if (this._setDatasetCreatePluggableViewsPreviouslyCalled) {
				return;
			}
			
			//Do some of our own work
			this._itemsTableView = new ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView({
				id: this.id + "_myTableView",
				parentPluggableView: this,
				widgetDefinitionId: "DefaultTopologySearchTable"
			});
			
			//Add the table view to the dialog
			this.addPluggableView(this._itemsTableView);

			//Register for selection changes
			dojo.connect(this._itemsTableView.selection, "onSelectionChanged", dojo.hitch(this, this._itemsTableViewSelectionHasChanged));
			
			//Make adjustment to dialog size
			dojo.attr(this._itemsTableView, "style", "height:" + "380px");
			dojo.attr(this, "style", "width:" + "450px");
			
			//*********************************
			//Add the buttons div to the dialog
			//*********************************
			//Button div
			var bottomButtonsDiv = dojo.create("div");
			dojo.style(bottomButtonsDiv,{
						backgroundColor: "#F7F7F7",			
						borderTopColor: "#DEDEDE",
						borderTopStyle: "solid",
						borderTopWidth: "1px",
						padding: "5px 5px 5px 10px"
			});
			bottomPane = new dijit.layout.ContentPane({id:this.id+"_bottomPane"},bottomButtonsDiv);		
			this.containerNode.appendChild(bottomButtonsDiv);

			//Center button
			if(this.isCenterInViewEnabled){
				this._centerInViewButton = new dijit.form.Button({
					id: this.id+"_centerInViewButton",
					label:this.commonResources.CENTER_IN_VIEW,
					disabled: true
				},bottomButtonsDiv.appendChild(dojo.create("div")));
				dojo.connect(this._centerInViewButton, "onClick", this, dojo.hitch(this,"_doCenterInView"));
			}

			//Highlight button
			this._highlightButton = new dijit.form.Button({
				id: this.id+"_highlightButton",
				label:this.commonResources.HIGHLIGHT, 
				disabled: true
			},bottomButtonsDiv.appendChild(dojo.create("div")));
			dojo.connect(this._highlightButton, "onClick", this, dojo.hitch(this,"_doHighlight"));

			//Clear search button
			if(this.isClearSearchEnabled){
				this._clearSearchButton = new dijit.form.Button({
					id: this.id+"_clearSearchButton",
					label:this.commonResources.CLEAR_SEARCH
				},bottomButtonsDiv.appendChild(dojo.create("div")));
				dojo.connect(this._clearSearchButton, "onClick", this, dojo.hitch(this,"_doClearSearch"));
			}	
			
			//Close search button
			if(this.isCloseSearchEnabled){
				this._closeSearchButton = new dijit.form.Button({
					id: this.id+"_closeSearchButton",
					label:this.commonResources.CLOSE
				},bottomButtonsDiv.appendChild(dojo.create("div")));
				dojo.connect(this._closeSearchButton, "onClick", this, dojo.hitch(this,"_doCloseSearch"));
			}
			
			//Remember we've been called
			this._setDatasetCreatePluggableViewsPreviouslyCalled = true;
			
			//Let's NOT call superclass
			//this.inherited(arguments);
		},
		
		_addPluggableViewToContainer: function(view) {
			this.containerNode.appendChild(view.domNode);
		},
		
		_removePluggableViewFromContainer: function(view) {
			this.containerNode.removeChild(view.domNode);
		},
		
		_datasetEventListenerCallback: function (/*Object*/ listenerObj, /*Object*/ event) {			
			//call super to do the rest of the event dispatching
			this.inherited(arguments);
			
			//Remember data changed while we were hidden
			if (this._isClosed) {
				this._dataChangedWhileHidden = true;
			}
		},
		
		//selection changed callback
		_itemsTableViewSelectionHasChanged: function(selection) {
			if (selection.getItemCount() > 0) {
				if (this._centerInViewButton) {
					this._centerInViewButton.setDisabled(false);
				}
				
				if (this._highlightButton) {
					this._highlightButton.setDisabled(false);
				}
			} else {
				if (this._centerInViewButton) {
					this._centerInViewButton.setDisabled(true);
				}
				
				if (this._highlightButton) {
					this._highlightButton.setDisabled(true);
				}
			}
		},
		
		_doClearSearch: function(){	
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Tell topo view to remove hightlights
			this.managingPluggableView.clearAllHighlights();		

			//Want clear out search on the ItemsTableView as well
			this._itemsTableView.setFilter(null);
		},
		
		_doHighlight: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// grid:
			//		Coming soon

			//Highlight objects
			this.managingPluggableView.setHighlightedObjectIds(this._itemsTableView.selection.getItemIds(), this._itemsTableView.selection.getLinkIds(), 
					this._itemsTableView.selection.getRelationshipIds());			

			if (this.hideOnCenterOrHighlight) {
				this.hide();
			}
		},
		
		_doCenterInView: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			//Center
			this.managingPluggableView.setZoomTo(this._itemsTableView.selection.getItemIds(), this._itemsTableView.selection.getLinkIds(), 
					this._itemsTableView.selection.getRelationshipIds(), 1.5); 
			
			//Highlight too
			this.managingPluggableView.setHighlightedObjectIds(this._itemsTableView.selection.getItemIds(), this._itemsTableView.selection.getLinkIds(), 
					this._itemsTableView.selection.getRelationshipIds());	
			
			if (this.hideOnCenterOrHighlight) {
				this.hide();
			}
		},
		
		_doCloseSearch: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			this.hide();
		}
});